from datetime import datetime
import secrets
from database import db

class Subscriber(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    email = db.Column(db.String(120), unique=True, nullable=False)
    created_at = db.Column(db.DateTime, default=datetime.utcnow)
    is_confirmed = db.Column(db.Boolean, default=False)
    confirmation_token = db.Column(db.String(100), unique=True)
    token_created_at = db.Column(db.DateTime)

    def __init__(self, email):
        self.email = email
        self.created_at = datetime.utcnow()
        self.is_confirmed = False
        self.confirmation_token = None
        self.token_created_at = None

    def generate_confirmation_token(self):
        self.confirmation_token = secrets.token_urlsafe(32)
        self.token_created_at = datetime.utcnow()
        return self.confirmation_token
